Realtime in JavaScript

Using ApexCharts with JavaScript

This Realtime example uses ApexCharts.js directly in JavaScript, with no wrapper component.

Install it with npm install apexcharts, then mount the chart with new ApexCharts(element, options).render().

JavaScript installation guide
var TICKINTERVAL = 1000
var XAXISRANGE = 29 * TICKINTERVAL
var lastX = new Date().getTime() - XAXISRANGE
var lastY = 50
var data = []

function nextValue() {
  lastY = Math.max(5, Math.min(95, lastY + (Math.random() - 0.5) * 20))
  return Math.round(lastY)
}

while (data.length < 30) {
  data.push({ x: lastX, y: nextValue() })
  lastX += TICKINTERVAL
}

var options = {
  series: [
    {
      name: 'Signal',
      data: data.slice(),
    },
  ],
  chart: {
    id: 'realtime-streaming',
    height: 350,
    type: 'line',
    streaming: {
      enabled: true,
    },
    animations: {
      dynamicAnimation: {
        speed: 1000,
      },
    },
    toolbar: {
      show: false,
    },
    zoom: {
      enabled: false,
    },
  },
  dataLabels: {
    enabled: false,
  },
  stroke: {
    curve: 'smooth',
  },
  title: {
    text: 'Streaming (bounded memory + linear scroll)',
    align: 'left',
  },
  markers: {
    size: 0,
  },
  xaxis: {
    type: 'datetime',
    range: XAXISRANGE,
  },
  yaxis: {
    min: 0,
    max: 100,
  },
  legend: {
    show: false,
  },
}

var chart = new ApexCharts(document.querySelector('#chart'), options)
chart.render()

var intervalRuns = 0
var interval = window.setInterval(function () {
  intervalRuns++

  lastX += TICKINTERVAL
  chart.appendData([
    {
      data: [{ x: lastX, y: nextValue() }],
    },
  ])

  if (intervalRuns === 2 && window.isATest === true) {
    clearInterval(interval)
  }
}, TICKINTERVAL)

Realtime in Vue

Using ApexCharts with Vue

This Realtime example wires ApexCharts into Vue through the vue3-apexcharts component.

Install it with npm install vue3-apexcharts apexcharts, then mount the chart with <apexchart type="..." :options="options" :series="series" />.

Vue charts guide
<template>
  <div>
    <div id="chart">
      <apexchart
        type="line"
        height="350"
        ref="chart"
        :options="chartOptions"
        :series="series"
      ></apexchart>
    </div>

    <div class="explanation">
      Real-time streaming with <code>chart.streaming.enabled</code>: each tick
      appends one point with <code>appendData()</code>. The window slides left
      at constant velocity (no easing pulse, no in-place warp), and the series
      array is trimmed automatically to the visible
      <code>xaxis.range</code> window, so memory stays flat no matter how long
      the stream runs. The same scroll works when a fixed-length rolling window
      is passed to <code>updateSeries()</code>.
    </div>
  </div>
</template>

<script>
import VueApexCharts from 'vue-apexcharts'

var TICKINTERVAL = 1000
var XAXISRANGE = 29 * TICKINTERVAL
var lastX = new Date().getTime() - XAXISRANGE
var lastY = 50
var data = []

function nextValue() {
  lastY = Math.max(5, Math.min(95, lastY + (Math.random() - 0.5) * 20))
  return Math.round(lastY)
}

while (data.length < 30) {
  data.push({ x: lastX, y: nextValue() })
  lastX += TICKINTERVAL
}

export default {
components: {
apexchart: VueApexCharts,
},
data: function () {
return {
series: [{
  name: 'Signal',
  data: data.slice()
}],
chartOptions: {
chart: {
  id: 'realtime-streaming',
  height: 350,
  type: 'line',
  streaming: {
    enabled: true
  },
  animations: {
    dynamicAnimation: {
      speed: 1000
    }
  },
  toolbar: {
    show: false
  },
  zoom: {
    enabled: false
  }
},
dataLabels: {
  enabled: false
},
stroke: {
  curve: 'smooth'
},
title: {
  text: 'Streaming (bounded memory + linear scroll)',
  align: 'left'
},
markers: {
  size: 0
},
xaxis: {
  type: 'datetime',
  range: XAXISRANGE
},
yaxis: {
  min: 0,
  max: 100
},
legend: {
  show: false
}
},
}
},
mounted: function () {
  var me = this
  window.setInterval(function () {
    lastX += TICKINTERVAL
    me.$refs.chart.appendData([{
      data: [{ x: lastX, y: nextValue() }]
    }])
  }, TICKINTERVAL)
},,
}
</script>

<style>
#chart {
  max-width: 650px;
  margin: 35px auto;
}
.explanation {
  max-width: 620px;
  margin: 0 auto 12px;
  font-size: 13px;
  color: #777;
}
</style>

Realtime in Angular

Using ApexCharts with Angular

This Realtime example wires ApexCharts into Angular through the ng-apexcharts component.

Install it with npm install ng-apexcharts apexcharts, then mount the chart with <apx-chart [series]="series" [chart]="chart"></apx-chart>.

Angular charts guide

This demo uses imperative chart updates. The generated code is a faithful Angular translation: open it in CodeSandbox to run and tweak.

import { Component, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
import {
  ChartComponent,
  ApexAxisChartSeries,
  ApexNonAxisChartSeries,
  ApexChart,
  ApexXAxis,
  ApexYAxis,
  ApexTitleSubtitle,
  ApexDataLabels,
  ApexStroke,
  ApexFill,
  ApexLegend,
  ApexTooltip,
  ApexMarkers,
  ApexPlotOptions,
  ApexResponsive,
  ApexGrid,
  ApexAnnotations,
  ApexStates,
  ApexTheme,
  NgApexchartsModule,
} from 'ng-apexcharts';

export type ChartOptions = {
  series?: ApexAxisChartSeries | ApexNonAxisChartSeries;
  chart?: ApexChart;
  xaxis?: ApexXAxis;
  yaxis?: ApexYAxis | ApexYAxis[];
  title?: ApexTitleSubtitle;
  subtitle?: ApexTitleSubtitle;
  dataLabels?: ApexDataLabels;
  stroke?: ApexStroke;
  fill?: ApexFill;
  legend?: ApexLegend;
  tooltip?: ApexTooltip;
  markers?: ApexMarkers;
  plotOptions?: ApexPlotOptions;
  responsive?: ApexResponsive[];
  grid?: ApexGrid;
  annotations?: ApexAnnotations;
  states?: ApexStates;
  theme?: ApexTheme;
  colors?: string[];
  labels?: any;
};

@Component({
  selector: 'app-chart',
  standalone: true,
  imports: [NgApexchartsModule],
  templateUrl: './chart.component.html',
})
export class AppChart implements AfterViewInit, OnDestroy {
  @ViewChild('chart') chart!: ChartComponent;
  private TICKINTERVAL: any = 1000;

  private XAXISRANGE: any = 29 * this.TICKINTERVAL;

  private lastX: any = new Date().getTime() - this.XAXISRANGE;

  private lastY: any = 50;

  private data: any = [];

  private nextValue = (): any => {
          this.lastY = Math.max(5, Math.min(95, this.lastY + (Math.random() - 0.5) * 20))
          return Math.round(this.lastY)
        };

  private intervalRuns: any = 0;

  private interval: any;

  public chartOptions: Partial<ChartOptions> = {
          series: [
            {
              name: 'Signal',
              data: this.data.slice(),
            },
          ],
          chart: {
            id: 'realtime-streaming',
            height: 350,
            type: 'line',
            streaming: {
              enabled: true,
            },
            animations: {
              dynamicAnimation: {
                speed: 1000,
              },
            },
            toolbar: {
              show: false,
            },
            zoom: {
              enabled: false,
            },
          },
          dataLabels: {
            enabled: false,
          },
          stroke: {
            curve: 'smooth',
          },
          title: {
            text: 'Streaming (bounded memory + linear scroll)',
            align: 'left',
          },
          markers: {
            size: 0,
          },
          xaxis: {
            type: 'datetime',
            range: this.XAXISRANGE,
          },
          yaxis: {
            min: 0,
            max: 100,
          },
          legend: {
            show: false,
          },
        };
  ngAfterViewInit() {
    (window as any).ApexCharts.setLicense('APEX-eyJleHBpcnlEYXRlIjoiMjEyNi0wNy0wNCIsImlzc3VlRGF0ZSI6IjIwMjYtMDctMjgiLCJwbGFuIjoicHJlbWl1bSIsImRvbWFpbnMiOlsiYXBleGNoYXJ0cy5jb20iLCIxMjcuMC4wLjEiLCJsb2NhbGhvc3QiXSwic2lnIjoieVBmb1VCc0Z3TU9ZdUEyaEZkR0I2Y1FtZ0JITUtXcVdJSjB2NVRESXRZbFR3eDJMUmh6R2x0RUc3VXJ4X0s3b25ZMWRZb2Z2VGItN01ydFYyNDVyOWcifQ==');
    while (this.data.length < 30) {
            this.data.push({ x: this.lastX, y: this.nextValue() })
            this.lastX += this.TICKINTERVAL
          }

    this.interval = window.setInterval(() => {
            this.intervalRuns++

            this.lastX += this.TICKINTERVAL
            this.chart.appendData([
              {
                data: [{ x: this.lastX, y: this.nextValue() }],
              },
            ])

            if (this.intervalRuns === 2 && (window as any).isATest === true) {
              clearInterval(this.interval)
            }
          }, this.TICKINTERVAL)
  }

  ngOnDestroy() {
    if (this.interval) clearInterval(this.interval);
  }
}

Realtime in React

Using ApexCharts with React

This Realtime example wires ApexCharts into React through the react-apexcharts component.

Install it with npm install react-apexcharts apexcharts, then mount the chart with <Chart type="..." options={options} series={series} />.

React charts guide
import React from 'react'
import ReactApexChart from 'react-apexcharts'
import ApexCharts from 'apexcharts'
import './styles.css'

var TICKINTERVAL = 1000
var XAXISRANGE = 29 * TICKINTERVAL
var lastX = new Date().getTime() - XAXISRANGE
var lastY = 50
var data = []

function nextValue() {
  lastY = Math.max(5, Math.min(95, lastY + (Math.random() - 0.5) * 20))
  return Math.round(lastY)
}

while (data.length < 30) {
  data.push({ x: lastX, y: nextValue() })
  lastX += TICKINTERVAL
}

const ApexChart = () => {
  const [state, setState] = React.useState({
    series: [
      {
        name: 'Signal',
        data: data.slice(),
      },
    ],
    options: {
      chart: {
        id: 'realtime-streaming',
        height: 350,
        type: 'line',
        streaming: {
          enabled: true,
        },
        animations: {
          dynamicAnimation: {
            speed: 1000,
          },
        },
        toolbar: {
          show: false,
        },
        zoom: {
          enabled: false,
        },
      },
      dataLabels: {
        enabled: false,
      },
      stroke: {
        curve: 'smooth',
      },
      title: {
        text: 'Streaming (bounded memory + linear scroll)',
        align: 'left',
      },
      markers: {
        size: 0,
      },
      xaxis: {
        type: 'datetime',
        range: XAXISRANGE,
      },
      yaxis: {
        min: 0,
        max: 100,
      },
      legend: {
        show: false,
      },
    },
  })

  React.useEffect(() => {
    const interval = window.setInterval(() => {
      lastX += TICKINTERVAL
      ApexCharts.exec('realtime-streaming', 'appendData', [
        {
          data: [{ x: lastX, y: nextValue() }],
        },
      ])
    }, TICKINTERVAL)
    return () => window.clearInterval(interval)
  }, [])

  return (
    <div>
      <div id="chart">
        <ReactApexChart
          options={state.options}
          series={state.series}
          type="line"
          height={350}
        />
      </div>

      <div className="explanation">
        Real-time streaming with <code>chart.streaming.enabled</code>: each tick
        appends one point with <code>appendData()</code>. The window slides left
        at constant velocity (no easing pulse, no in-place warp), and the series
        array is trimmed automatically to the visible <code>xaxis.range</code>{' '}
        window, so memory stays flat no matter how long the stream runs. The
        same scroll works when a fixed-length rolling window is passed to{' '}
        <code>updateSeries()</code>.
      </div>
    </div>
  )
}

export default ApexChart